local _
local mainFrame  = CreateFrame("Frame", nil, UIParent)

local mobIDs = {
  73174, -- Archiereus of Flame
  72775, -- Bufo
  73171, -- Champion of the Blackflame
  72045, -- Chelon
  73175, -- Cinderfall
  72049, -- Cranegnasher
  73281, -- Dread Ship Vazuvius
  73158, -- Emerald Gander
  73279, -- Evermaw
  73172, -- Flintlord Gairan
  73282, -- Garnia
  72970, -- Golganarr
  73161, -- Great Turtle Furyshell
  72909, -- Gu'chi the Swarmbringer
  73167, -- Huolon
  73163, -- Imperial Python
  73160, -- Ironfur Steelhorn
  73169, -- Jakur of Ordon
  72193, -- Karkanos
  73277, -- Leafmender
  73166, -- Monsterous Spineclaw
  72048, -- Rattleskew
  73157, -- Rock Moss
  71864, -- Spelurk
  72769, -- Spirit of Jadefire
  73704, -- Stinkbraid
  72808, -- Tsavo'ka <Ghost in the Darkness>
  73173, -- Urdur the Cauterizer
  73170, -- Watcher Osu
  72245, -- Zesqua
  71919, -- Zhu-Gon the Sour
}

local mobs = {
  -- npc_id = {message sent, died time, name, min spawn time, max spawn time, coordsX, coordsY, lastRequest}
  -- Timeless Isle (map 951)
  -- Many of the spawn timers are guesses, will need to refine when data is available
  [73174] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Archiereus of Flame
  [72775] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Bufo
  [73171] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Champion of the Blackflame
  [72045] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Chelon
  [73175] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Cinderfall
  [72049] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Cranegnasher
  [73281] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Dread Ship Vazuvius
  [73158] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn =  900, maxSpawn = 1800, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Emerald Gander
  [73279] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Evermaw
  [73172] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Flintlord Gairan
  [73282] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Garnia
  [72970] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Golganarr
  [73161] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn =  900, maxSpawn = 1800, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Great Turtle Furyshell
  [72909] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Gu'chi the Swarmbringer
  [73167] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Huolon
  [73163] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn =  900, maxSpawn = 1800, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Imperial Python
  [73160] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Ironfur Steelhorn
  [73169] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Jakur of Ordon
  [72193] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Karkanos
  [73277] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Leafmender
  [73166] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Monsterous Spineclaw
  [72048] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Rattleskew
  [73157] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Rock Moss
  [71864] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Spelurk
  [72769] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Spirit of Jadefire
  [73704] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Stinkbraid
  [72808] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Tsavo'ka <Ghost in the Darkness>
  [73173] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Urdur the Cauterizer
  [73170] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Watcher Osu
  [72245] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Zesqua
  [71919] = { msgSent = 0, killTime = 0, npcName = nil, minSpawn = 1800, maxSpawn = 3600, coordsX = 0, coordsY = 0, lastRequest = 0 }, -- Zhu-Gon the Sour
}

local message
local message_mob_id
local timer, throttle = 0, 3
local text_timer, text_throttle = 0, 10

-- =========== New Frame Start =========== --
-- Design:
-- |-------- MainFrame -------------------------------------------|
-- ||------- NPC Name -------------------------|----  Killed ----||
-- || Some NPC Name                            |       1min      ||
-- || Some NPC Name                            |      15min      ||
-- || Some NPC Name                            |       1min      ||
-- || Some NPC Name                            |       1min      ||
-- || Some NPC Name                            |       1min      ||
-- || Some NPC Name                            |       1min      ||
-- || Some NPC Name                            |       1min      ||
-- ||------------------------------------------------------------||
-- |--------------------------------------------------------------|

local rareFrame = CreateFrame("Frame", "rareFrame", UIParent)
  rareFrame:SetWidth(300)
  rareFrame:SetHeight(30)
  rareFrame:SetPoint("LEFT", 300, 100)
  rareFrame:SetMovable(true)
  rareFrame:EnableMouse(true)
  rareFrame:RegisterForDrag("LeftButton")
  rareFrame:SetScript("OnDragStart", mainFrame.StartMoving)
  rareFrame:SetScript("OnDragStop", mainFrame.StopMovingOrSizing)
  rareFrame:SetUserPlaced(true)

  rareFrame.npcFrame = CreateFrame("Frame", "rareFrame.npcFrame", rareFrame)
  rareFrame.npcFrame:SetWidth(230)
  rareFrame.npcFrame:SetHeight(rareFrame:GetHeight()-10)
  rareFrame.npcFrame:SetPoint("TOPLEFT", rareFrame, 5, -5)
  rareFrame.npcFrame.texture = rareFrame:CreateTexture(nil, "BACKGROUND")
  rareFrame.npcFrame.texture:SetTexture(0,0,0,0.7)
  rareFrame.npcFrame.texture:SetAllPoints(rareFrame.npcFrame)

  rareFrame.timeFrame = CreateFrame("Frame", "rareFrame.timeFrame", rareFrame)
  rareFrame.timeFrame:SetWidth(70)
  rareFrame.timeFrame:SetHeight(rareFrame:GetHeight()-10)
  rareFrame.timeFrame:SetPoint("TOPLEFT", rareFrame.npcFrame, "TOPRIGHT", 0, 0)
  rareFrame.timeFrame.texture = rareFrame:CreateTexture(nil, "BACKGROUND")
  rareFrame.timeFrame.texture:SetTexture(0,0,0,0.7)
  rareFrame.timeFrame.texture:SetAllPoints(rareFrame.timeFrame)

rareFrame.npcFrame.text = {}
local i
local validCount = 0
for i=0, table.getn(mobIDs) do
  if (i == 0) then
    -- Header
    rareFrame.npcFrame.text[i] = rareFrame.npcFrame:CreateFontString("rareFrame.npcFrame.text["..i.."]", nil, "GameFontNormal")
    rareFrame.npcFrame.text[i]:SetPoint("TOP", "rareFrame.npcFrame", 2, -2 + -14.*i)
    rareFrame.npcFrame.text[i]:SetFont("Fonts\\ARIALN.TTF", 12)
    rareFrame.npcFrame.text[i]:SetTextColor(1, 0.7, 0, 1)
    rareFrame.npcFrame.text[i]:SetText("Name")
    rareFrame.npcFrame.text[i]:SetFont("Fonts\\ARIALN.TTF", 12,"OUTLINE")
  elseif (i > 0) then
    if mobIDs[i] ~= nil then
      if (mobs[mobIDs[i]].npcName ~= nil) then
        validCount = validCount + 1
        rareFrame.npcFrame.text[validCount] = rareFrame.npcFrame:CreateFontString("rareFrame.npcFrame.text["..validCount.."]", nil, "GameFontNormal")
        rareFrame.npcFrame.text[validCount]:SetPoint("TOP", "rareFrame.npcFrame", 2, -2 + -14.* validCount)
        rareFrame.npcFrame.text[validCount]:SetFont("Fonts\\ARIALN.TTF", 12)
        rareFrame.npcFrame.text[validCount]:SetTextColor(1, 0.8, 0, 1)
        rareFrame.npcFrame.text[validCount]:SetText(mobs[mobIDs[i]].npcName)
      end
    end
  end
end

rareFrame.timeFrame.text = {}
local i
local validCount = 0
for i=0, table.getn(mobIDs) do
  if (i == 0) then
    -- Header
    rareFrame.timeFrame.text[i] = rareFrame.timeFrame:CreateFontString("rareFrame.timeFrame.text["..i.."]", nil, "GameFontNormal")
    rareFrame.timeFrame.text[i]:SetPoint("TOP", "rareFrame.timeFrame", 2, -2 + -14.*i)
    rareFrame.timeFrame.text[i]:SetFont("Fonts\\ARIALN.TTF", 12)
    rareFrame.timeFrame.text[i]:SetTextColor(1, 0.7, 0, 1)
    rareFrame.timeFrame.text[i]:SetText("Killed")
    rareFrame.timeFrame.text[i]:SetFont("Fonts\\ARIALN.TTF", 12,"OUTLINE")
  elseif (i > 0) then
    if mobIDs[i] ~= nil then
      if (mobs[mobIDs[i]].npcName ~= nil) then
        validCount = validCount + 1
        rareFrame.timeFrame.text[validCount] = rareFrame.timeFrame:CreateFontString("rareFrame.timeFrame.text["..validCount.."]", nil, "GameFontNormal")
        rareFrame.timeFrame.text[validCount]:SetPoint("TOP", "rareFrame.timeFrame", 2, -2 + -14.* validCount)
        rareFrame.timeFrame.text[validCount]:SetFont("Fonts\\ARIALN.TTF", 12)
        rareFrame.timeFrame.text[validCount]:SetTextColor(1, 0.8, 0, 1)
        rareFrame.timeFrame.text[validCount]:SetText(SecondsToTime(GetTime() - mobs[mobIDs[i]].killTime, true))
      end
    end
  end
end
-- =========== New Frame End   =========== --

local function DeathTimes(self,elapsed)
  text_timer = text_timer + elapsed
  if text_timer >= text_throttle then
    -- == New frame start == --
    if (rareFrame.npcFrame ~= nil) then
      if (rareFrame.npcFrame.text ~= nil) then
        -- Loop through our rare mobs, check if we have a name and kill time, then search for it in npcFrame
        -- if it is there, update the time, otherwise add it
        local textIndex = 0
        local rareIndex = 0
        local textFound = false
        for rareIndex = 0, table.getn(mobIDs) do
          if (mobs[mobIDs[rareIndex]] ~= nil) then
            if (mobs[mobIDs[rareIndex]].npcName ~= nil) then
              textFound = false

              for textIndex = 0, table.getn(rareFrame.npcFrame.text) do
                if (rareFrame.npcFrame.text[textIndex]:GetText() == mobs[mobIDs[rareIndex]].npcName) then
                  textFound = true
                  if (mobs[mobIDs[rareIndex]].killTime ~= nil) then
                    local timeSinceKill = GetTime() - mobs[mobIDs[rareIndex]].killTime
                    local mediumSpawn = (mobs[mobIDs[rareIndex]].minSpawn + mobs[mobIDs[rareIndex]].maxSpawn) / 2
                    rareFrame.timeFrame.text[textIndex]:SetText(SecondsToTime(timeSinceKill, true))
                    -- Set the text colour
                    -- KillTime < Minimum Spawn time
                    if (timeSinceKill < mobs[mobIDs[rareIndex]].minSpawn) then
                      rareFrame.timeFrame.text[textIndex]:SetTextColor(1, 0.8, 0, 1) -- Normal
                    -- KillTime > Minimum Spawn time, but < Maximum Spawn time
                    -- and < 1/2 of the Average between Min and Max
                    elseif ((timeSinceKill > mobs[mobIDs[rareIndex]].minSpawn) and
                             (timeSinceKill < mediumSpawn)) then
                      rareFrame.timeFrame.text[textIndex]:SetTextColor(1, 1, 0, 1) -- Yellow
                    -- KillTime > Minimum Spawn time, but < Maximum Spawn time
                    -- and > 1/2 of the Average between Min and Max
                    elseif ((timeSinceKill > mediumSpawn) and
                            (timeSinceKill < mobs[mobIDs[rareIndex]].maxSpawn)) then
                      rareFrame.timeFrame.text[textIndex]:SetTextColor(0, 1, 0, 1) -- Green
                    -- KillTime > Maximum Spawn time. Either kill missed or no announcement
                    else
                      rareFrame.timeFrame.text[textIndex]:SetTextColor(1, 0, 0, 1) -- Red
                    end
                  else
                    rareFrame.timeFrame.text[textIndex]:SetText("Alive")
                    rareFrame.timeFrame.text[textIndex]:SetTextColor(0, 0.8, 1, 1) -- Green
                  end
                end
              end

              -- First time the rare has been killed, so add it to the frame
              if (textFound == false) then
                local newIndex = table.getn(rareFrame.npcFrame.text) + 1
                rareFrame.npcFrame.text[newIndex] = rareFrame.npcFrame:CreateFontString("rareFrame.npcFrame.text["..newIndex.."]", nil, "GameFontNormal")
                rareFrame.npcFrame.text[newIndex]:SetPoint("TOP", "rareFrame.npcFrame", 2, -2 + -14.* newIndex)
                rareFrame.npcFrame.text[newIndex]:SetFont("Fonts\\ARIALN.TTF", 12)
                rareFrame.npcFrame.text[newIndex]:SetTextColor(1, 0.8, 0, 1)
                rareFrame.npcFrame.text[newIndex]:SetText(mobs[mobIDs[rareIndex]].npcName)

                rareFrame.timeFrame.text[newIndex] = rareFrame.timeFrame:CreateFontString("rareFrame.timeFrame.text["..newIndex.."]", nil, "GameFontNormal")
                rareFrame.timeFrame.text[newIndex]:SetPoint("TOP", "rareFrame.timeFrame", 2, -2 + -14.* newIndex)
                rareFrame.timeFrame.text[newIndex]:SetFont("Fonts\\ARIALN.TTF", 12)
                rareFrame.timeFrame.text[newIndex]:SetTextColor(1, 0.8, 0, 1)
                if (mobs[mobIDs[rareIndex]].killTime ~= nil) then
                  rareFrame.timeFrame.text[newIndex]:SetText(SecondsToTime(GetTime() - mobs[mobIDs[rareIndex]].killTime, true))
                else
                  rareFrame.timeFrame.text[newIndex]:SetText("Killed")
                end
              end
            end
          end
        end
        rareFrame.npcFrame:SetHeight(25 +  table.getn(rareFrame.npcFrame.text) *14)
        rareFrame.timeFrame:SetHeight(25 +  table.getn(rareFrame.npcFrame.text) *14)
        rareFrame:SetHeight(25 +  table.getn(rareFrame.npcFrame.text) *14)
      end
    end
    -- == New frame end == --
    text_timer = 0
  end
end

local function init()
  -- MapAreaID 951 = Timeless Isles
  if (GetCurrentMapAreaID() == 951) then
    mainFrame:RegisterEvent("CHAT_MSG_CHANNEL")
    mainFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
    mainFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    --textframe:Show()
    --textframe:SetScript("OnUpdate", DeathTimes)
    rareFrame:Show()
    rareFrame:SetScript("OnUpdate", DeathTimes)
  else
    mainFrame:UnregisterEvent("CHAT_MSG_CHANNEL")
    mainFrame:UnregisterEvent("PLAYER_TARGET_CHANGED")
    mainFrame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    --textframe:Hide()
    --textframe:SetScript("OnUpdate", nil)
    rareFrame:Hide()
    rareFrame:SetScript("OnUpdate", nil)
    end
end

local lastRareRequest
local responseFormater = CreateFrame("Button")
responseFormater:Hide()
local function ProcessRequest()
  -- Expected format = raretime <npcname / id>
  if (lastRareRequest ~= nil) then
    local searchingString
    
    if (strlower(string.sub(msg,1,9)) == "raretime ") then
      searchingString = string.sub(lastRareRequest, 10, string.len(lastRareRequest))
    elseif (strlower(string.sub(msg,1,10)) == "raretimer ") then
      searchingString = string.sub(lastRareRequest, 11, string.len(lastRareRequest))
    else
      return
    end

    if (string.len(searchingString) > 3) then
      local responseString

      -- First check if for ID
      local searchID = tonumber(searchingString)
      if (searchID ~= nil) then
        if (mobs[searchID] ~= nil) then
          -- We throttle the number of requests per mob to once every 2mins
          if ((GetTime() - mobs[searchID].lastRequest) > 120) and
             (mobs[searchID].npcName ~= nil) and
             (mobs[searchID].killTime) then
            if ((GetTime() - mobs[searchID].killTime) > 60) then
              responseString = "RA: (".. searchID ..") " .. mobs[searchID].npcName .. " was last killed " .. tostring(SecondsToTime(GetTime() - mobs[searchID].killTime, true)) .. " ago."
            else
              responseString = "RA: (".. searchID ..") " .. mobs[searchID].npcName .. " was last killed less than a minute ago."
            end

            mobs[searchID].lastRequest = GetTime()
          end
        end
      -- Now search on name or part of name
      else
        searchingString = strlower(searchingString)
        local i
        for i= 1, table.getn(mobIDs) do
          if (mobs[mobIDs[i]] ~= nil) then
            if (mobs[mobIDs[i]].npcName ~= nil) and
               (mobs[mobIDs[i]].killTime ~= nil) then
              -- Full or partial match
              if (strlower(mobs[mobIDs[i]].npcName) == searchingString) or
                 (string.find(strlower(mobs[mobIDs[i]].npcName), searchingString) ~= nil) then
                -- We throttle the number of requests per mob to once every 2mins
                if ((GetTime() - mobs[mobIDs[i]].lastRequest) > 120) then
                  if ((GetTime() - mobs[mobIDs[i]].killTime) > 60) then
                    responseString = "RA: (".. mobIDs[i] ..") " .. mobs[mobIDs[i]].npcName .. " was last killed " .. tostring(SecondsToTime(GetTime() - mobs[mobIDs[i]].killTime, true)) .. " ago."
                  else
                    responseString = "RA: (".. mobIDs[i] ..") " .. mobs[mobIDs[i]].npcName .. " was last killed less than a minute ago."
                  end

                  mobs[mobIDs[i]].lastRequest = GetTime()
                end

                -- Found, so stop the for loop
                break
              end
            end
          end
        end
      end

      if (responseString ~= nil) then
        -- For some reason the SendChatMessage does not like the output from SecondsToTime
        -- this is a work around
        responseString = responseFormater:GetText(responseFormater:SetText(responseString))
        SendChatMessage(responseString , "CHANNEL", nil, 1)
        --SendChatMessage(responseString , "CHANNEL", nil, 4)
      end
    end

    lastRareRequest = nil
  end
end

local function update(self,elapsed)
    timer = timer + elapsed;
    if (timer >= throttle) then
      if (mobs[message_mob_id] ~= nil) then
        if mobs[message_mob_id].msgSent + 10 < GetTime() then
          SendChatMessage(message , "CHANNEL", nil, 1)
          -- SendChatMessage(message , "CHANNEL", nil, 4) -- TESTING
        end
      end

      -- Process any outstanding last kill requests
      ProcessRequest()

      message_mob_id = nil
      timer = 0
      mainFrame:SetScript("OnUpdate", nil)
    end
end

local function RandomizeTime()
  throttle = math.random()*3
  mainFrame:SetScript("OnUpdate", update)
end

local function events(mainFrame, event, ...)
  if event == "COMBAT_LOG_EVENT_UNFILTERED" then
    local _,event_type,_,_,_,_,_,guid,name = select(1, ...)

    if event_type == "UNIT_DIED" then
      name = strtrim(name)
      local id = tonumber(guid:sub(6, 10), 16)
      if not mobs[id] then return end
      mobs[id].killTime = GetTime()
      mobs[id].npcName = name
      message = "npc"..id..": "..name.." (0%)"
      message_mob_id = id
      RandomizeTime()
    end
  elseif event == "PLAYER_TARGET_CHANGED" then
    local guid = UnitGUID("target")
    if guid and mobs[tonumber(guid:sub(6, 10), 16)] and not UnitIsDead("target") then
      local id = tonumber(guid:sub(6, 10), 16)
      local name = strtrim(UnitName("target"))
      local x, y = GetPlayerMapPosition("player")
      local hp = math.floor(UnitHealth("target")*100/UnitHealthMax("target"))
      message = "npc"..id..": "..name.." ("..hp.."%). Coordinates: "..math.floor(x*100)..", "..math.floor(y*100)
      message_mob_id = id
      mobs[id].killTime = nil -- Reset the kill time to Alive
      mobs[id].npcName = name
      RandomizeTime()
    end
  elseif event == "CHAT_MSG_CHANNEL" then
    local msg,sentBy,_,_,_,_,_,channel = select(1, ...)
    if (channel == 1) then
      -- Death Announce string
      if (string.sub(msg,1,3) == "npc") then
        local id = tonumber(string.sub(msg,4,8))
        if mobs[id] then
            -- If this is a death announce, set the last killed time
          if (string.sub(msg, string.len(msg)-4, string.len(msg))) == " (0%)" then
            -- First we try and get the name of the mob from the ": " part
            local spacerStart, spacerEnd = string.find(msg, ": ")
            if (spacerEnd) then
              -- to the " (0%)" part
            local percStart, percEnd = string.find(msg, " %(0%%%)")
            if (percStart) then
              local name = strtrim(string.sub(msg, spacerEnd + 1, percStart))
              mobs[id].killTime = GetTime()
              mobs[id].npcName = name
            end
            end
          else
            mobs[id].msgSent = GetTime()
          end
        end
      -- Request string
      elseif (strlower(string.sub(msg,1,9)) == "raretime ") or
             (strlower(string.sub(msg,1,10)) == "raretimer ") then
        -- Expected format =  ratime <npc name/id>
        lastRareRequest = msg
        RandomizeTime()
      -- Request response string
      elseif (strlower(string.sub(msg,1,5)) == "ra: (") then
        lastRareRequest = nil
      end
    end
  elseif(event == "PLAYER_ENTERING_WORLD" or event == "ZONE_CHANGED_NEW_AREA") then
    init()
  end
end

mainFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
mainFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
mainFrame:SetScript("OnEvent", events)
